<?php

namespace Drupal\field_zip_file\Plugin\Field\FieldFormatter;

use Drupal\Core\Field\FieldItemListInterface;
use Drupal\field_zip_file\Plugin\Field\FieldType\ZipFileItem;

/**
 * Formatter that shows the file size in a human readable way.
 *
 * @FieldFormatter(
 *   id = "zip_file_iframe",
 *   label = @Translation("iFrame"),
 *   field_types = {
 *     "zip_file"
 *   }
 * )
 */
class ZipFileIFrame extends ZipFileBase {

  /**
   * {@inheritdoc}
   */
  public function viewElements(FieldItemListInterface $items, $langcode) {
    $elements = [];

    foreach ($items as $delta => $item) {
      $elements[$delta] = $this->renderIframe($item);
    }

    return $elements;
  }

  /**
   * Render iframe.
   */
  protected function renderIframe(ZipFileItem $zip_file) {
    return [
      '#theme' => 'zip_file_iframe',
      '#url' => $this->getUrl($zip_file),
    ];
  }

}
